/*******************************************************************************
* File Name: InputCounter2.c
* Version 1.0
*
* Description:
*  This file provides the source code to the API for the InputCounter2
*  component
*
********************************************************************************
* Copyright 2016-2017, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#include "InputCounter2.h"

/** Indicates whether or not the InputCounter2 has been initialized. 
*  The variable is initialized to 0 and set to 1 the first time 
*  InputCounter2_Start() is called. This allows the Component to 
*  restart without reinitialization after the first call to 
*  the InputCounter2_Start() routine.
*/
uint8_t InputCounter2_initVar = 0U;

/** The instance-specific configuration structure. This should be used in the 
*  associated InputCounter2_Init() function.
*/ 
cy_stc_tcpwm_counter_config_t const InputCounter2_config =
{
        .period = 16777213UL,
        .clockPrescaler = 0UL,
        .runMode = 0UL,
        .countDirection = 0UL,
        .compareOrCapture = 0UL,
        .compare0 = 16777213UL,
        .compare1 = 16384UL,
        .enableCompareSwap = false,
        .interruptSources = 0UL,
        .captureInputMode = 3UL,
        .captureInput = CY_TCPWM_INPUT_CREATOR,
        .reloadInputMode = 0UL,
        .reloadInput = CY_TCPWM_INPUT_CREATOR,
        .startInputMode = 0UL,
        .startInput = CY_TCPWM_INPUT_CREATOR,
        .stopInputMode = 1UL,
        .stopInput = CY_TCPWM_INPUT_CREATOR,
        .countInputMode = 0UL,
        .countInput = CY_TCPWM_INPUT_CREATOR,
};


/*******************************************************************************
* Function Name: InputCounter2_Start
****************************************************************************//**
*
*  Calls the InputCounter2_Init() when called the first time and enables 
*  the InputCounter2. For subsequent calls the configuration is left 
*  unchanged and the component is just enabled.
*
* \globalvars
*  \ref InputCounter2_initVar
*
*******************************************************************************/
void InputCounter2_Start(void)
{
    if (0U == InputCounter2_initVar)
    {
        (void)Cy_TCPWM_Counter_Init(InputCounter2_HW, InputCounter2_CNT_NUM, &InputCounter2_config); 

        InputCounter2_initVar = 1U;
    }

    Cy_TCPWM_Enable_Multiple(InputCounter2_HW, InputCounter2_CNT_MASK);
    
    #if (InputCounter2_INPUT_DISABLED == 0UL)
        Cy_TCPWM_TriggerStart(InputCounter2_HW, InputCounter2_CNT_MASK);
    #endif /* (InputCounter2_INPUT_DISABLED == 0UL) */    
}


/* [] END OF FILE */
